import { Base } from "./Base.mjs"
import { login } from "../../account.mjs"

function redirectBack() {
    const next = m.route.param("next")
    try {
        if (!next.startsWith("/")) {
            throw new Error("Invalid next path.")
        }
        m.route.set(next)
    } catch (e) {
        m.route.set("/")
    }
}

function onLoginClicked() {
    document
        .querySelectorAll("form input")
        .forEach(element => (element.disabled = true))

    login(
        document.querySelector("#username").value,
        document.querySelector("#password").value,
    )
        .then(redirectBack)
        .catch(error => {
            document
                .querySelectorAll("form input")
                .forEach(element => (element.disabled = false))
            alert(
                "Anmeldung fehlgeschlagen: CL-Account-Name oder Passwort wurden von Portal nicht erkannt.",
            )
        })
}

export const Login = {
    oncreate() {
        document.title = "Anmelden · FS Coli Portal"
    },
    view() {
        return m(
            Base,
            m("article.box", [
                m("h1", "Anmelden"),
                m(
                    "form",
                    {
                        onsubmit: function (event) {
                            onLoginClicked()
                            event.preventDefault() // don't let the browser send GET or POST requests...
                        },
                    },
                    [
                        m("input#username", {
                            required: true,
                            placeholder: "CL-Account-Name",
                        }),
                        m("input#password[type='password']", {
                            required: true,
                            placeholder: "Passwort",
                        }),
                        m("input", { type: "submit", value: "Anmelden" }),
                    ],
                ),
            ]),
        )
    },
}
